<?php
/*
 * Módulo de autenticación LDAP para consigna
 *
 *  Daniel García Moreno <danigm@us.es>
 *  Jorge López Pérez <jorgelp@us.es>
 *
 *   noviembre de 2007
 */

/** 
 *  Devuelve el nombre completo del usuario si tiene exito.
 *  En otro caso devuelve FALSE
 */
function compruebaUsuario($usuario, $pass) {
    $ds = @ldap_connect($GLOBALS["hostldap"],$GLOBALS["puertoldap"]);
    if ($ds) {
        if (@ldap_bind($ds, $GLOBALS["usuarioldap"], $GLOBALS["passldap"]) != TRUE) {
            loggear('ldap: No se ha podido hacer bind');
            return FALSE; // Devolvemos falso. Registramos el error
        }

        // Búsqueda
        $dn = "dc=us,dc=es";
        $filtro = "uid=".$usuario;
        $necesitamos = array('givenName', 'sn1', 'dn');

        $sr = @ldap_search($ds, $dn, $filtro, $necesitamos);

        if ($sr == FALSE) {
            loggear('ldap: Fallo de busqueda');
            return FALSE;
        } else {
            $info = @ldap_get_entries($ds, $sr);

            if ($info['count'] == 0) {
                loggear('ldap: No se ha podido encontrar el usuario: '.$usuario);
                return FALSE;
            }
            // Accedemos a los datos del usuario,
            // están en $info[0]['atributo']
            $dn2 = $info[0]['dn'];

            $ret = @ldap_bind($ds, $dn2, $pass);
            @ldap_unbind($ds);
            if ($ret)
                return $info[0]['givenname'][0].' '.$info[0]['sn1'][0];
            else {
                loggear('ldap: No se ha podido validar la contraseña del usuario: '.$usuario);
                return FALSE;
            }
        }
    } else {
        loggear('ldap: No se puede conectar');
    }
}

/*
 * Sección de autenticación
 */

function autenticaLDAP() {
	$usuario = $_POST['usuario'];
	$pass = $_POST['contrasen'];

	if (($nombrecompleto = compruebaUsuario($usuario, $pass)) == FALSE) {
		show_error("Autenticaci&oacute;n fallida. Comprueba tu nombre de usuario y contrase&ntilde;a.");
	} else {
		$_SESSION['usuarioldap'] = $nombrecompleto;
	}
}

/**
 * Realiza logout de la sesión del usuario autenticado previamente
 * en LDAP
 */

function logoutLDAP() {
	// Simplemente borramos la variable de sesión
	$_SESSION['usuarioldap'] = "";
}

?>
